C
C **************************************************************
C     Transforming LaSilla ESO 0.50-m uvby into Data B of HEC22
C     S. Stefl; Version 01: May 02, 1995
C     Correction for grey filters not included
C **************************************************************
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TEX(10),TX(5),V(4),U(4),D(4),TS(4)
      INTEGER*2 NS(200),JH(4),JM(4),NSS(4),NMODE,MODE(2)
      CHARACTER*1 ZSS,SS(2),FIL,BAR(4),NEXT(4)
      CHARACTER*6 NGT
      CHARACTER*8 HV,S(200),OBS
      CHARACTER*12 INP,OUT
C
      COMMON /DTC/ DT
C     Definition of special data values
C
      DATA BAR/'y','b','u','v'/,MODE/0,1/
      DATA SS/'*','B'/,NEXT/'y','Y','n','N'/
      DTE=5.8D-8
      DTH=7.7D-8
C
C     Input formats
C
  101 FORMAT(11X,F6.5,23X,I3,2X,A8,1X,1A)
  102 FORMAT(4X,1A,5X,F8.0)
  103 FORMAT(A8,I8)
C
C     Output formats
C
  202 FORMAT(5A8)
  203 FORMAT(F3.0,I3,I5,4H 412)
  204 FORMAT(I1,I4,2I3,F9.4,1X,F10.1)
  205 FORMAT(5H    0)
  206 FORMAT(10A8)
  207 FORMAT('Night ',A6,' ESO 0.5-m uvby 'A8,1X)
C
C Formats of error messages
C
  301 FORMAT(' Error: Star ',A8,' is missing in table of objects')
  302 FORMAT(' Error in data sequence at GJD = ',F8.5)
  303 FORMAT(' Error: Undifined filter at GJD= ',F8.5)
  304 FORMAT(' Warning: Star:',A8, 'GJD= ',F8.5, A1,'-filter:')
  305 FORMAT('  !!!  Counts above the accepted limit  !!!')
  306 FORMAT(' Error:',I2,'-unvalid mode specification (must be 0/1)')
  307 FORMAT(' ERROR: undifined star/sky parameter at GJD:',F8.5)
  308 FORMAT(' Error:',I2,'-unvalid tube specification (must be 1/2)')
C
C
   29 CONTINUE
      PRINT *,' The photomultiplier used (1 - EMI, 2 - HAMA):'
      READ(*,*) NTUBE
      IF(NTUBE .EQ. 1) DT = DTE
      IF(NTUBE .EQ. 2) DT = DTH
      IF((NTUBE .NE. 1) .AND. (NTUBE .NE. 2)) WRITE(*,308) NTUBE
      IF((NTUBE .NE. 1) .AND. (NTUBE .NE. 2)) GO TO 29
      PRINT *,' Mode of the transformation? (0 or 1):'
      READ(*,*) NMODE
      OPEN(3,FILE='TAB.CON',STATUS='OLD')
C
C     Input of table of star names and specifications
C
      NN=0
    3 READ(3,103,END=1) HV,K
      NN=NN+1
      S(NN)=HV
      NS(NN)=K
      GO TO 3
C
    1 CONTINUE
      PRINT *,' Input file of ESO 0.5-m data?'
      READ(*,'(A)') INP
      PRINT *,'Output HEC22 data file?'
      READ(*,'(A)') OUT
      OPEN(1,FILE=INP,STATUS='OLD')
      OPEN(2,FILE=OUT,STATUS='NEW')
C
C
      READ(1,206) TEX
      WRITE(*,206) TEX
C
    2 PRINT *,'Night No.? (max. 6 characters, e.g.: 25/92)'
      READ(*,'(A)') NGT
      PRINT *,'Observer? (max. 8 characters)'
      READ(*,'(A)') OBS
      WRITE(2,207) NGT,OBS
      WRITE(*,207) NGT,OBS
      PRINT *,'Comments on quality, weather etc. (max. 40 characters!)'
      PRINT *,'<                                     >'
      READ(*,206) TX
      WRITE(2,202) TX
      PRINT *,'Date of the beginning of the night (day, month, year)?'
      READ(*,*) DEN,M,J
      WRITE(2,203) DEN,M,J
C
C     Input of observations begins
C
    6 IF(NMODE.EQ.MODE(2)) GO TO 40
      IF(NMODE.EQ.MODE(1)) GO TO 7
      WRITE(2,306) NMODE
      WRITE(*,306) NMODE
      STOP 13
C
C     Input of stellar deflections  - mode 0:
C
    7 CONTINUE
      DO 21 J=1,4
      D(J)=0
      JH(J)=0
      JM(J)=0
      TS(J)=0
   21 CONTINUE
      DO 5 JJ=1,4
      READ(1,101,END=10) GJD,IT,HV,ZSS
      READ(1,102,END=10) FIL,Q
      IF(ZSS .NE. SS(1)) GO TO 20
      DO 22 J=1,4
      IF(FIL .NE. BAR(J)) GO TO 22
      NC=J
      GO TO 23
   22 CONTINUE
      WRITE(2,303) GJD
      WRITE(*,303) GJD
      STOP 13
   23 CONTINUE
      DO 4 J=1,NN
      IF(S(J).NE.HV) GO TO 4
      NSS(NC)=NS(J)
      T=24D0*(GJD-5.787037D-6*IT)
      JH(NC)=T
      T=60D0*(T-JH(NC))
      JM(NC)=T
      TS(NC)=60D0*(T-JM(NC))
      JH(NC)=JH(NC)+8
      V(NC)=Q/IT
      IF(V(NC).GT.500000.) WRITE(*,304) HV,GJD
      IF(V(NC).GT.500000.) WRITE(*,305)
      GO TO 5
    4 CONTINUE
      WRITE(2,301) HV
      WRITE(*,301) HV
      STOP 13
    5 CONTINUE
      GO TO 8
   20 CONTINUE
      WRITE(2,302) GJD
      WRITE(*,302) GJD
      STOP 13
    8 CONTINUE
      IF(NSS(1).NE.NSS(2)) GO TO 20
      IF(NSS(2).NE.NSS(3)) GO TO 20
      IF(NSS(3).NE.NSS(4)) GO TO 20
      N=NSS(1)
C
C     Input of sky readings - mode 1:
C
      DO 25 JJ=1,4
      READ(1,101,END=10) GJD,IT,HV,ZSS
      READ(1,102,END=10) FIL,Q
      IF(ZSS .NE. SS(2)) GO TO 20
      DO 26 J=1,4
      IF(FIL.NE.BAR(J)) GO TO 26
      NC=J
      GO TO 27
   26 CONTINUE
      WRITE(2,303) GJD
      WRITE(*,303) GJD
      STOP 13
   27 CONTINUE
      U(NC)=Q/IT
   25 CONTINUE
C
C     Write the data in the output file - mode 0:
C
      DO 30 J=1,4
      CALL DEAD(V(J))
      CALL DEAD(U(J))
      Q=V(J)-U(J)
      WRITE(2,204) J,N,JH(J),JM(J),TS(J),Q
   30 CONTINUE
      GO TO 7
C
C     Input of the observations - mode 1:
C
   40 CONTINUE
      DO 42 J=1,4
      JH(J)=0
      JM(J)=0
      TS(J)=0
   42 CONTINUE
      READ(1,101,END=10) GJD,IT,HV,ZSS
      READ(1,102,END=10) FIL,Q
      DO 43 J=1,4
      IF(FIL .NE. BAR(J)) GO TO 43
      NC=J
      GO TO 44
   43 CONTINUE
      WRITE(2,303) GJD
      WRITE(*,303) GJD
      STOP 13
   44 CONTINUE
      IF(ZSS.EQ.SS(2)) N=-1
      IF(ZSS.EQ.SS(2)) GO TO 47
      IF(ZSS.EQ.SS(1)) GO TO 45
      WRITE(2,307) GJD
      WRITE(*,307) GJD
      STOP 13
   45 CONTINUE
      DO 46 J=1,NN
      IF(S(J).NE.HV) GO TO 46
      N=NS(J)
      GO TO 47
   46 CONTINUE
      WRITE(2,301) HV
      WRITE(*,301) HV
      STOP 13
   47 CONTINUE
      T=24D0*(GJD-5.787037D-6*IT)
      JH(NC)=T
      T=60D0*(T-JH(NC))
      JM(NC)=T
      TS(NC)=60D0*(T-JM(NC))
      JH(NC)=JH(NC)+8
      V(NC)=Q/IT
      IF(V(NC).GT.500000.) WRITE(*,304) HV,GJD
      IF(V(NC).GT.500000.) WRITE(*,305)
      Q=V(NC)
C
C     Write the data in the output file - mode 0:
C
      WRITE(2,204) NC,N,JH(NC),JM(NC),TS(NC),Q
      GO TO 40
C
   10 WRITE(2,205)
      PRINT *,'Next file to be transformed? (y/n)'
      READ(*,'(A)') ZSS
      IF((ZSS.EQ.NEXT(1)).OR.(ZSS.EQ.NEXT(2))) GO TO 1
      STOP 7
      END
C
C
      SUBROUTINE DEAD(A)
C
C     CALCULATION OF THE DEAD-TIME CORRECTION
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /DTC/ T
C
      IF(A.EQ.0D0) RETURN
      B=A
    1 C=B
      B=A*DEXP(T*B)
      IF(DABS((B-C)/B).GT.1.D-8) GO TO 1
      A=B
      RETURN
      END





