C
C     Program SORTARCH.F      release 4         December 10, 2015
C
C     Combining and sorting photometric archives
C
C     Rel. 2 permits combination of an unlimited number of archives at one run
C            and automatically recognizes the older and newer type of Table of objects
C            i.e. tables for less then 1000 objects and the larger ones.
C
C     Rel. 3 has corrected the error in the final list of JD range
C            for a single observation of a star
C
C     Rel. 4 has corrected format 100 to ensure that HD comp. is treated
C            properly for archives with 4 passbands

      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 HD,HD2,HD3(1000000)
      CHARACTER*1 BL,BLANK/1H /
      CHARACTER*66 D,DATA,DATA2,DATA3(1000000)
      REAL*8 HJD3(1000000)
      CHARACTER*12 INP,INP2,INP77,OUT,JMENO
      COMMON /DAT/ HJD(1000000),HD(1000000),DATA(1000000)
      COMMON /DAT2/ HJD2(100000),HD2(100000),DATA2(100000)
  100 FORMAT(I7,F11.4,A66)
C
      EXTERNAL ORDER,ORDER2,MOVE,MOVE2
C
      JARCH=0
      JTAB=0
      N=0
      HJDMIN=1.D99
      HJDMAX=0D0
C
      PRINT *,'Number of passbands in the archives (3 or 4)?'
      READ(*,*) NCOL
      PRINT *,'Which table of objects?'
      READ(*,'(A)') INP77
      PRINT *,'Input file of the archive to be sorted?'
      READ(*,'(A)') INP
      PRINT *,'Name of the output sorted archive?'
      READ(*,'(A)') OUT
      OPEN(77,FILE=INP77,STATUS='OLD')
      OPEN(1,FILE=INP,STATUS='OLD')
      OPEN(2,FILE=OUT,STATUS='NEW')
C
C     Testing whether the smaller or larger Table of objects is read
C
      READ(77,7007) BL
 7007 FORMAT(3X,A1)
      IF(BL.NE.BLANK) JTAB=1
      BACKSPACE77
C
C     Testing whether the archive is differential (KARCH=-2)
C                                  or all-sky one (KARCH=-1)
C
      KARCH=-1
      IF(NCOL.EQ.3) READ(1,7030) J
 7030 FORMAT(70X,I7)
      IF(NCOL.EQ.4) READ(1,7040) J
 7040 FORMAT(77X,I7)
      IF(J.NE.0) KARCH=-2
      BACKSPACE 1
C
    1 READ(1,*,END=7) JHD
      IF(JHD.LT.0) GO TO 7
      BACKSPACE1
      READ(1,100,END=7) JHD,H,D
      N=N+1
      HD(N)=JHD
      HJD(N)=H
      DATA(N)=D
      IF(HJDMIN.GT.H) HJDMIN=H
      IF(HJDMAX.LT.H) HJDMAX=H
      GO TO 1
C
    7 PRINT *,'Do you wish to add another archive?  0=no'
      READ(*,*) JARCH
      IF(JARCH.EQ.0) GO TO 8
      PRINT *,'Input file of another archive to be added?'
      READ(*,'(A)') INP2
      OPEN(11,FILE=INP2,STATUS='OLD')
      IF(NCOL.EQ.3) READ(11,7030) J
      IF(NCOL.EQ.4) READ(11,7040) J
      BACKSPACE 11
      IF(J.EQ.0.AND.KARCH.EQ.-1) GO TO 9
      IF(J.NE.0.AND.KARCH.EQ.-2) GO TO 9
      IF(J.EQ.0.AND.KARCH.EQ.-2) WRITE(*,7213) INP,INP2
      IF(J.NE.0.AND.KARCH.EQ.-1) WRITE(*,7113) INP,INP2
 7113 FORMAT(' Please, change your specification, you are trying',
     *       ' to combine'/' all-sky archive',1X,A12,
     *       ' and differential archive',1X,A12)
 7213 FORMAT(' Please, change your specification, you are trying',
     *       ' to combine'/' differential archive',1X,A12,
     *       ' and all-sky archive',1X,A12)
      STOP 1313
    9 READ(11,*,END=6) JHD
      IF(JHD.GE.0) GO TO 15
    6 CLOSE(11)
      GO TO 7
   15 BACKSPACE11
      READ(11,100,END=8) JHD,H,D
      N=N+1
      HD(N)=JHD
      HJD(N)=H
      DATA(N)=D
      IF(HJDMIN.GT.H) HJDMIN=H
      IF(HJDMAX.LT.H) HJDMAX=H
      GO TO 9
C
    8 CALL GENSHL(N,ORDER,MOVE)
      I=0
      L=0
      M=0
      NS=1
    4 L=L+1
      I=I+1
      JHD=HD(L)
      HD2(I)=JHD
      HJD2(I)=HJD(L)
      DATA2(I)=DATA(L)
      K=L+1
      IF(K.LE.N.AND.HD(K).EQ.JHD) GO TO 4
C
      CALL GENSHL(I,ORDER2,MOVE2)
      DO 3 J=1,I
      M=M+1
      HD3(M)=HD2(J)
      HJD3(M)=HJD2(J)
    3 DATA3(M)=DATA2(J)
      IF(L.GE.N) GO TO 5
      I=0
      NS=NS+1
      GO TO 4
C
    5 DO 2 J=1,N
    2 WRITE(2,100) HD3(J),HJD3(J),DATA3(J)
C
C     Appending the list of the objects in the archive
C
C     N... number of the records in the archive
C     M... number of records for a given star
C     L... running number of the first record for the given
C          star in the sorted archive
C     K... running number of just tested record of the archive
C
      WRITE(2,7002) KARCH,NS,N,HJDMIN,HJDMAX
 7002 FORMAT(I5,I7,I10,2F12.4)
      M=1
      L=1
      K=1
   10 IF(K.EQ.L) HDMIN=HJD3(L)
      IF(HD3(K+1).NE.HD3(K)) GO TO 11
      M=M+1
      K=K+1
      IF(K.LE.N) GO TO 10
   11 HDMAX=HJD3(K)
   14 IF(JTAB.NE.0) READ(77,7010,END=13) JHD,JMENO
      IF(JTAB.EQ.0) READ(77,7110,END=13) JHD,JMENO
 7010 FORMAT(62X,I6,A12)
 7110 FORMAT(61X,I6,A12)
      IF(JHD.NE.HD3(K)) GO TO 14
      WRITE(2,7005) JHD,HDMIN,HDMAX,L,M,JMENO
 7005 FORMAT(I7,2F12.4,2I8,A12)
      K=K+1
      L=K
      M=1
      REWIND 77
      IF(K.LT.N) GO TO 10
C
      STOP 7
C
   13 WRITE(*,7013) HD3(K)
 7013 FORMAT(' Star HD',I7,' is not in Table of objects')
      STOP 13
      END
C
C
C     SORTING GENERAL RECORDS BY SHELL'S METHOD
C
      SUBROUTINE GENSHL(N,ORDER,MOVE)
C     N=NUMBER OF SORTED RECORDS
C     LOGICAL FUNCTION ORDER(I,J) TESTS WHETHER I-TH RECORD IS IN RIGHT
C     ORDER COMPARED WITH J-TH RECORD (USER SUPPLIED)
C     SUBROUTINE MOVE(I,J) MOVES I-TH RECORD INTO J-TH ONE
C     (USER SUPPLIED)
C     BOTH USER SUPPLIED SUBPROGRAMS MAY BE CALLED WITH I OR J
C     EQUAL TO (N+1), IN THAT CASE PLACE FOR TEMPORARY (WORKING)
C     RECORD IS REFERENCED, USER MUST PROVIDE SPACE FOR THIS RECORD
      INTEGER N,D,I,J,I1,I2,N1
      LOGICAL ORDER
      N1=N+1
      I=1
    6 I1=I+I
      IF(I1.GT.N) GO TO 7
      I=I1
      GO TO 6
    7 D=I-1
    1 IF(D.LE.0)RETURN
      I=1
    2 J=I
      I1=I+D
      CALL MOVE(I1,N1)
    3 IF(ORDER(N1,J)) GO TO 4
    5 I2=J+D
      CALL MOVE(N1,I2)
      I=I+1
      IF(I+D.LE.N) GO TO 2
      D=(D-1)/2
      GO TO 1
    4 I2=J+D
      CALL MOVE(J,I2)
      J=J-D
      IF(J)5,5,3
      END
C
      SUBROUTINE MOVE(I,J)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 HD,HD2
      CHARACTER*66 DATA,DATA2
      COMMON /DAT/ HJD(1000000),HD(1000000),DATA(1000000)
      COMMON /DAT2/ HJD2(100000),HD2(100000),DATA2(100000)
      HJD(J)=HJD(I)
      HD(J)=HD(I)
      DATA(J)=DATA(I)
      RETURN
      END
C
      SUBROUTINE MOVE2(I,J)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 HD,HD2
      CHARACTER*66 DATA,DATA2
      COMMON /DAT/ HJD(1000000),HD(1000000),DATA(1000000)
      COMMON /DAT2/ HJD2(100000),HD2(100000),DATA2(100000)
      HJD2(J)=HJD2(I)
      HD2(J)=HD2(I)
      DATA2(J)=DATA2(I)
      RETURN
      END
C
      LOGICAL FUNCTION ORDER(I,J)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 HD,HD2
      CHARACTER*66 DATA,DATA2
      COMMON /DAT/ HJD(1000000),HD(1000000),DATA(1000000)
      COMMON /DAT2/ HJD2(100000),HD2(100000),DATA2(100000)
      ORDER=HD(I).LE.HD(J)
      RETURN
      END
C
      LOGICAL FUNCTION ORDER2(I,J)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 HD,HD2
      CHARACTER*66 DATA,DATA2
      COMMON /DAT/ HJD(1000000),HD(1000000),DATA(1000000)
      COMMON /DAT2/ HJD2(100000),HD2(100000),DATA2(100000)
      ORDER2=HJD2(I).LE.HJD2(J)
      RETURN
      END
C
C
C
